Package org.apache.ignite.internal.processors.cache.persistence

## Interface DatabaseLifecycleListener

    public interface DatabaseLifecycleListener

### Method Summary

All Methods Instance Methods Default Methods
`default void` `afterBinaryMemoryRestore​(IgniteCacheDatabaseSharedManager mgr, GridCacheDatabaseSharedManager.RestoreBinaryState restoreState)` Callback executed when binary memory has fully restored and WAL logging is resumed.
`default void` `afterInitialise​(IgniteCacheDatabaseSharedManager mgr)` Callback executed after all data regions are initialized.
`default void` `afterLogicalUpdatesApplied​(IgniteCacheDatabaseSharedManager mgr, GridCacheDatabaseSharedManager.RestoreLogicalState restoreState)` Callback executed when all logical updates were applied and page memory become to fully consistent state.
`default void` `beforeBinaryMemoryRestore​(IgniteCacheDatabaseSharedManager mgr)` Callback executed right before node become perform binary recovery.
`default void` `beforeResumeWalLogging​(IgniteCacheDatabaseSharedManager mgr)` Callback executed when all physical updates are applied and we are ready to write new physical records during logical recovery.
`default void` `beforeStop​(IgniteCacheDatabaseSharedManager mgr)` Callback executed before shared manager will be stopped.
`default void` `onBaselineChange()` Callback executed when node detected that baseline topology is changed and node is not in that baseline.
`default void` `onInitDataRegions​(IgniteCacheDatabaseSharedManager mgr)` Callback executed when data regions become to start-up.

### Method Detail

#### onInitDataRegions

    default void onInitDataRegions​(IgniteCacheDatabaseSharedManager mgr)
                            throws IgniteCheckedException

Callback executed when data regions become to start-up.

Parameters:
  `mgr` - Database shared manager.
Throws:
  `IgniteCheckedException` - If failed.

#### onBaselineChange

    default void onBaselineChange()
                           throws IgniteCheckedException

Callback executed when node detected that baseline topology is changed and node is not in that baseline. It's useful to cleanup and invalidate all available data restored at that moment.

Throws:
  `IgniteCheckedException` - If failed.

#### beforeBinaryMemoryRestore

    default void beforeBinaryMemoryRestore​(IgniteCacheDatabaseSharedManager mgr)
                                    throws IgniteCheckedException

Callback executed right before node become perform binary recovery.

Parameters:
  `mgr` - Database shared manager.
Throws:
  `IgniteCheckedException` - If failed.

#### afterBinaryMemoryRestore

    default void afterBinaryMemoryRestore​(IgniteCacheDatabaseSharedManager mgr,
                                          GridCacheDatabaseSharedManager.RestoreBinaryState restoreState)
                                   throws IgniteCheckedException

Callback executed when binary memory has fully restored and WAL logging is resumed.

Parameters:
  `mgr` -
  `restoreState` - Result of binary recovery.
Throws:
  `IgniteCheckedException` - If failed.

#### afterLogicalUpdatesApplied

    default void afterLogicalUpdatesApplied​(IgniteCacheDatabaseSharedManager mgr,
                                            GridCacheDatabaseSharedManager.RestoreLogicalState restoreState)
                                     throws IgniteCheckedException

Callback executed when all logical updates were applied and page memory become to fully consistent state.

Parameters:
  `mgr` -
  `restoreState` - Result of logical recovery.
Throws:
  `IgniteCheckedException` - If failed.

#### beforeResumeWalLogging

    default void beforeResumeWalLogging​(IgniteCacheDatabaseSharedManager mgr)
                                 throws IgniteCheckedException

Callback executed when all physical updates are applied and we are ready to write new physical records during logical recovery.

Parameters:
  `mgr` - Database shared manager.
Throws:
  `IgniteCheckedException` - If failed.

#### afterInitialise

    default void afterInitialise​(IgniteCacheDatabaseSharedManager mgr)
                          throws IgniteCheckedException

Callback executed after all data regions are initialized.

Parameters:
  `mgr` - Database shared manager.
Throws:
  `IgniteCheckedException`

#### beforeStop

    default void beforeStop​(IgniteCacheDatabaseSharedManager mgr)

Callback executed before shared manager will be stopped.

Parameters:
  `mgr` - Database shared manager.